# Pssecret server

[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)

Pssecret is self-hosted service to share secrets (like passwords) with somebody
over the network, but don't want them to appear in chats, unencrypted e-mails, etc.

This service tries to be as anonymous as possible. The only personal information that will be stored
on a server will be IP address of the client that made request to the server.

Service is built with Python, FastAPI and is using Redis for data storage.

## Installation

### Requirements

- Python 3.11+
- Redis
- Python development libraries (optional, only needed for `hiredis` module installation)

### How to install

The recommended installation method is with the [pipx](https://pipx.pypa.io/stable/)

```console
$ pipx install pssecret-server
```

For faster performance, install application with [hiredis](https://github.com/redis/hiredis) support.

```console
$ pipx install pssecret-server[hiredis]
```

### Running Pssecret server

Make sure you have the Redis service running.

After installation is done, you can start pssecret server with `pssecret-server` command.
The web server will be started with `uvicorn` ASGI web server.

```console
$ pssecret-server
```

### Configuration

Configuration is done via environment variables.

Environment variables:

- `REDIS_URL`: URL for Redis access. Check what values are supported [here](https://redis.readthedocs.io/en/stable/connections.html#redis.Redis.from_url).

You can also declare these variables in a `.env` file in the working directory.
